当前位置:首页 > linux教程 > 列表

多master/develop分支如何使用gitflow版本控制

发布:smiling 来源: PHP粉丝网  添加日期:2015-04-21 15:10:34 浏览: 评论:0 

在使用 gitflow 做版本控制系统,发现gitflow的时候只能指定一个master/develop,如果要多分支使用要如何操作呢?那么来看看我是如何给gitflow加料的。

公司都是git作为版本控制,公司一些项目组在用gitflow,但是我们组没有强制,但是我上月出了一次事故,总结就是分支管理问题,所以开始强迫自己使用gitflow,以前的项目是一个master和一个develop,自己checkout一个分支,然后merge(不理解的可以看看a-successful-git-branching-model).

问题出现了:项目有几个主分支和开发分支,比如master_sina,master_qq. master_buzz ,而gitflow的时候只能指定一个master/develop, 这样你start一个feature/hotfix之前就要去.git/config里面修改 [gitflow “branch”]项的相关主分支和开发分支,so不方便,看了下源码,给gitflow加点料.

添加功能

当你打开了feature/hotfix分支,但是你不想要它了(当然你可以直接git branch -D xx),使用git flow hotfix/feature delete,自动帮你删除这个分支,以便你新建其他分支(git flow只容许你一次存在一个hotfix/feature分支).

你想使用gitflow删除其它存在分支嘛?不需要 git branch -D,你还可以git flow hotfix/feature delete XX.

比如我在init的时候指定了master为master_sina,而当我想创建master_qq的hotfix,我只需要在start的是否给它取名字是’qq_‘开头的即可,要是有其它的需要你可以直接在源码里面添加对应的内容.

例子 git-flow-hotfix 我主要标记我修改的部分,代码如下:

  1. init() { 
  2.   require_git_repo 
  3.   require_gitflow_initialized 
  4.   gitflow_load_settings 
  5.   VERSION_PREFIX=$(eval "echo `git config --get gitflow.prefix.versiontag`"
  6.   PREFIX=$(git config --get gitflow.prefix.hotfix) 
  7. # 增加help的选项说明 
  8. usage() { 
  9.     echo "usage: git flow hotfix [list] [-v]" 
  10.     echo "       git flow hotfix start [-F] <version> [<base>]" 
  11.     echo "       git flow hotfix finish [-Fsumpk] <version>" 
  12.     echo "       git flow hotfix publish <version>" 
  13.     echo "       git flow hotfix delete [branch]" 
  14.     echo "       git flow hotfix track <version>" 
  15. cmd_default() { 
  16.     cmd_list "$@" 
  17.  
  18. cmd_list() { 
  19.     DEFINE_boolean verbose false 'verbose (more) output' v 
  20.     parse_args "$@" 
  21.  
  22.     local hotfix_branches 
  23.     local current_branch 
  24.     local short_names 
  25.     hotfix_branches=$(echo "$(git_local_branches)" | grep "^$PREFIX"
  26.     if [ -z "$hotfix_branches" ]; then 
  27.         warn "No hotfix branches exist." 
  28.                 warn "" 
  29.                 warn "You can start a new hotfix branch:" 
  30.                 warn "" 
  31.                 warn "    git flow hotfix start <version> [<base>]" 
  32.                 warn "" 
  33.         exit 0 
  34.     fi 
  35.     current_branch=$(git branch --no-color | grep '^* ' | grep -v 'no branch' | sed 's/^* //g') 
  36.     short_names=$(echo "$hotfix_branches" | sed "s ^$PREFIX  g"
  37.  
  38.     # determine column width first 
  39.     local width=0 
  40.     local branch 
  41.     for branch in $short_names; do 
  42.         local len=${#branch} 
  43.         width=$(max $width $len) 
  44.     done 
  45.     width=$(($width+3)) 
  46.  
  47.     local branch 
  48.     for branch in $short_names; do 
  49.         local fullname=$PREFIX$branch 
  50.         local base=$(git merge-base "$fullname" "$MASTER_BRANCH"
  51.         local master_sha=$(git rev-parse "$MASTER_BRANCH"
  52.         local branch_sha=$(git rev-parse "$fullname"
  53.         if [ "$fullname" = "$current_branch" ]; then 
  54.             printf "* " 
  55.         else 
  56.             printf "  " 
  57.         fi 
  58.         if flag verbose; then 
  59.             printf "%-${width}s" "$branch" 
  60.             if [ "$branch_sha" = "$master_sha" ]; then 
  61.                 printf "(no commits yet)" 
  62.             else  --phpfensi.com 
  63.                 local tagname=$(git name-rev --tags --no-undefined --name-only "$base") 
  64.                 local nicename 
  65.                 if [ "$tagname" != "" ]; then 
  66.                     nicename=$tagname 
  67.                 else 
  68.                     nicename=$(git rev-parse --short "$base") 
  69.                 fi 
  70.                 printf "(based on $nicename)" 
  71.             fi 
  72.         else 
  73.             printf "%s" "$branch" 
  74.         fi 
  75.         echo 
  76.     done 
  77.  
  78. cmd_help() { 
  79.     usage 
  80.     exit 0 
  81.  
  82. parse_args() { 
  83.     # parse options 
  84.     FLAGS "$@" || exit $? 
  85.     eval set -- "${FLAGS_ARGV}" 
  86.     # read arguments into global variables 
  87.     VERSION=$1 
  88.     BRANCH=$PREFIX$VERSION 

这里就是我多master/develop的技巧,我这里会判断要新建的分支的前缀,要是qq_开头就会基于master_qq和develop_qq创建分支,所以你可以根据你的需要在这里加一些方法.

  1. test `expr match "$@" "qq_"` -ne 0 && MASTER_BRANCH="$MASTER_BRANCH"_qq && 
  2.     DEVELOP_BRANCH="$DEVELOP_BRANCH"_qq 
  3.  
  4. require_version_arg() { 
  5.     if [ "$VERSION" = "" ]; then 
  6.         warn "Missing argument <version>" 
  7.         usage 
  8.         exit 1 
  9.     fi 
  10.  
  11. require_base_is_on_master() { 
  12.     if ! git branch --no-color --contains "$BASE" 2>/dev/null  
  13.             | sed 's/[* ] //g'  
  14.             | grep -q "^$MASTER_BRANCH$"; then 
  15.         die "fatal: Given base '$BASE' is not a valid commit on '$MASTER_BRANCH'." 
  16.     fi 
  17.  
  18. require_no_existing_hotfix_branches() { 
  19.     local hotfix_branches=$(echo "$(git_local_branches)" | grep "^$PREFIX") 
  20.     local first_branch=$(echo ${hotfix_branches} | head -n1) 
  21.     first_branch=${first_branch#$PREFIX} 
  22.     [ -z "$hotfix_branches" ] ||  
  23.         die "There is an existing hotfix branch ($first_branch). Finish that one first." 
  24. # 添加delete 参数,函数需要cmd_开头 
  25. cmd_delete() { 
  26.     if [ "$1" = "" ]; then 
  27.         # 当不指定参数自动去找存在的未关闭的gitflow分支 
  28.         local hotfix_branches=$(echo "$(git_local_branches)" | grep "^$PREFIX") 
  29.         test "$hotfix_branches" = "" && die "There has not existing hotfix branch can delete" && exit 1 
  30.     else 
  31.         # 指定参数先判断参数是不是的数量格式 
  32.         test $# != 1 && die "There only need one parameter indicates the branch to be deleted" && exit 1 
  33.         hotfix_branches="$1" 
  34.     fi 
  35.     # 当要删除的分支就是当前分支,先checkout到develop分支 
  36.     test "$hotfix_branches" = "$(git_current_branch)" && echo 'First checkout develp branch'; git_do checkout "$DEVELOP_BRANCH" 
  37.     git branch -D  ${hotfix_branches} > /dev/null 2>&1&& echo 'Delete Successed'|| die "Did not find branch: [$hotfix_branches]" 
  38.  
  39. cmd_start() { 
  40.     DEFINE_boolean fetch false "fetch from $ORIGIN before performing finish" F 
  41.     parse_args "$@" 
  42.     BASE=${2:-$MASTER_BRANCH} 
  43.     require_version_arg 
  44.     require_base_is_on_master 
  45.     require_no_existing_hotfix_branches 
  46.  
  47.     # sanity checks 
  48.     require_clean_working_tree 
  49.     require_branch_absent "$BRANCH" 
  50.     require_tag_absent "$VERSION_PREFIX$VERSION" 
  51.     if flag fetch; then 
  52.         git_do fetch -q "$ORIGIN" "$MASTER_BRANCH" 
  53.     fi 
  54.     if has "$ORIGIN/$MASTER_BRANCH" $(git_remote_branches); then 
  55.         require_branches_equal "$MASTER_BRANCH" "$ORIGIN/$MASTER_BRANCH" 
  56.     fi 
  57.  
  58.     # create branch 
  59.     git_do checkout -b "$BRANCH" "$BASE" 
  60.  
  61.     echo 
  62.     echo "Summary of actions:" 
  63.     echo "- A new branch '$BRANCH' was created, based on '$BASE'" 
  64.     echo "- You are now on branch '$BRANCH'" 
  65.     echo 
  66.     echo "Follow-up actions:" 
  67.     echo "- Bump the version number now!" 
  68.     echo "- Start committing your hot fixes" 
  69.     echo "- When done, run:" 
  70.     echo 
  71.     echo "     git flow hotfix finish '$VERSION'" 
  72.     echo 
  73.  
  74. cmd_publish() { 
  75.     parse_args "$@" 
  76.     require_version_arg 
  77.  
  78.     # sanity checks 
  79.     require_clean_working_tree 
  80.     require_branch "$BRANCH" 
  81.     git_do fetch -q "$ORIGIN" 
  82.     require_branch_absent "$ORIGIN/$BRANCH" 
  83.  
  84.     # create remote branch 
  85.     git_do push "$ORIGIN" "$BRANCH:refs/heads/$BRANCH" 
  86.     git_do fetch -q "$ORIGIN" 
  87.  
  88.     # configure remote tracking 
  89.     git config "branch.$BRANCH.remote" "$ORIGIN" 
  90.     git config "branch.$BRANCH.merge" "refs/heads/$BRANCH" 
  91.     git_do checkout "$BRANCH" 
  92.  
  93.     echo 
  94.     echo "Summary of actions:" 
  95.     echo "- A new remote branch '$BRANCH' was created" 
  96.     echo "- The local branch '$BRANCH' was configured to track the remote branch" 
  97.     echo "- You are now on branch '$BRANCH'" 
  98.     echo 
  99.  
  100. cmd_track() { 
  101.     parse_args "$@" 
  102.     require_version_arg 
  103.  
  104.     # sanity checks 
  105.     require_clean_working_tree 
  106.     require_branch_absent "$BRANCH" 
  107.     git_do fetch -q "$ORIGIN" 
  108.     require_branch "$ORIGIN/$BRANCH" 
  109.  
  110.     # create tracking branch 
  111.     git_do checkout -b "$BRANCH" "$ORIGIN/$BRANCH" 
  112.  
  113.     echo 
  114.     echo "Summary of actions:" 
  115.     echo "- A new remote tracking branch '$BRANCH' was created" 
  116.     echo "- You are now on branch '$BRANCH'" 
  117.     echo 
  118.  
  119. cmd_finish() { 
  120.     DEFINE_boolean fetch false "fetch from $ORIGIN before performing finish" F 
  121.     DEFINE_boolean sign false "sign the release tag cryptographically" s 
  122.     DEFINE_string signingkey "" "use the given GPG-key for the digital signature (implies -s)" u 
  123.     DEFINE_string message "" "use the given tag message" m 
  124.     DEFINE_string messagefile "" "use the contents of the given file as tag message" f 
  125.     DEFINE_boolean push false "push to $ORIGIN after performing finish" p 
  126.     DEFINE_boolean keep false "keep branch after performing finish" k 
  127.     DEFINE_boolean notag false "don't tag this release" n 
  128.     parse_args "$@" 
  129.     require_version_arg 
  130.  
  131.     # handle flags that imply other flags 
  132.     if [ "$FLAGS_signingkey" != "" ]; then 
  133.         FLAGS_sign=$FLAGS_TRUE 
  134.     fi 
  135.  
  136.     # sanity checks 
  137.     require_branch "$BRANCH" 
  138.     require_clean_working_tree 
  139.     if flag fetch; then 
  140.         git_do fetch -q "$ORIGIN" "$MASTER_BRANCH" ||  
  141.           die "Could not fetch $MASTER_BRANCH from $ORIGIN." 
  142.         git_do fetch -q "$ORIGIN" "$DEVELOP_BRANCH" ||  
  143.           die "Could not fetch $DEVELOP_BRANCH from $ORIGIN." 
  144.     fi 
  145.     if has "$ORIGIN/$MASTER_BRANCH" $(git_remote_branches); then 
  146.         require_branches_equal "$MASTER_BRANCH" "$ORIGIN/$MASTER_BRANCH" 
  147.     fi 
  148.     if has "$ORIGIN/$DEVELOP_BRANCH" $(git_remote_branches); then 
  149.         require_branches_equal "$DEVELOP_BRANCH" "$ORIGIN/$DEVELOP_BRANCH" 
  150.     fi 
  151.  
  152.     # try to merge into master 
  153.     # in case a previous attempt to finish this release branch has failed, 
  154.     # but the merge into master was successful, we skip it now 
  155.     if ! git_is_branch_merged_into "$BRANCH" "$MASTER_BRANCH"; then 
  156.         git_do checkout "$MASTER_BRANCH" ||  
  157.           die "Could not check out $MASTER_BRANCH." 
  158.         git_do merge --no-ff "$BRANCH" ||  
  159.           die "There were merge conflicts." 
  160.           # TODO: What do we do now? 
  161.     fi 
  162.  
  163.     if noflag notag; then 
  164.         # try to tag the release 
  165.         # in case a previous attempt to finish this release branch has failed, 
  166.         # but the tag was set successful, we skip it now 
  167.         local tagname=$VERSION_PREFIX$VERSION 
  168.         if ! git_tag_exists "$tagname"; then 
  169.             local opts="-a" 
  170.             flag sign && opts="$opts -s" 
  171.             [ "$FLAGS_signingkey" != "" ] && opts="$opts -u '$FLAGS_signingkey'" 
  172.             [ "$FLAGS_message" != "" ] && opts="$opts -m '$FLAGS_message'" 
  173.             [ "$FLAGS_messagefile" != "" ] && opts="$opts -F '$FLAGS_messagefile'" 
  174.             eval git_do tag $opts "$VERSION_PREFIX$VERSION" "$BRANCH" ||  
  175.             die "Tagging failed. Please run finish again to retry." 
  176.         fi 
  177.     fi 
  178.  
  179.     # try to merge into develop 
  180.     # in case a previous attempt to finish this release branch has failed, 
  181.     # but the merge into develop was successful, we skip it now 
  182.     if ! git_is_branch_merged_into "$BRANCH" "$DEVELOP_BRANCH"; then 
  183.         git_do checkout "$DEVELOP_BRANCH" ||  
  184.           die "Could not check out $DEVELOP_BRANCH." 
  185.  
  186.         # TODO: Actually, accounting for 'git describe' pays, so we should 
  187.         # ideally git merge --no-ff $tagname here, instead! 
  188.         git_do merge --no-ff "$BRANCH" ||  
  189.           die "There were merge conflicts." 
  190.           # TODO: What do we do now? 
  191.     fi 
  192.  
  193.     # delete branch 
  194.     if noflag keep; then 
  195.         # 这个问题很奇怪,在完成分支删除它也会存在当前分支是 
  196.         # 要删除的分支删除报错的问题,所以先切换走 
  197.         test "$BRANCH" = "$(git_current_branch)" && git_do checkout "$DEVELOP_BRANCH" 
  198.         git_do branch -d "$BRANCH" 
  199.     fi 
  200.  
  201.     if flag push; then 
  202.         git_do push "$ORIGIN" "$DEVELOP_BRANCH" ||  
  203.             die "Could not push to $DEVELOP_BRANCH from $ORIGIN." 
  204.         git_do push "$ORIGIN" "$MASTER_BRANCH" ||  
  205.             die "Could not push to $MASTER_BRANCH from $ORIGIN." 
  206.         if noflag notag; then 
  207.             git_do push --tags "$ORIGIN" ||  
  208.                 die "Could not push tags to $ORIGIN." 
  209.         fi 
  210.     fi 
  211.  
  212.     echo 
  213.     echo "Summary of actions:" 
  214.     echo "- Latest objects have been fetched from '$ORIGIN'" 
  215.     echo "- Hotfix branch has been merged into '$MASTER_BRANCH'" 
  216.     if noflag notag; then 
  217.         echo "- The hotfix was tagged '$VERSION_PREFIX$VERSION'" 
  218.     fi 
  219.     echo "- Hotfix branch has been back-merged into '$DEVELOP_BRANCH'" 
  220.     if flag keep; then 
  221.         echo "- Hotfix branch '$BRANCH' is still available" 
  222.     else 
  223.         echo "- Hotfix branch '$BRANCH' has been deleted" 
  224.     fi 
  225.     if flag push; then 
  226.         echo "- '$DEVELOP_BRANCH', '$MASTER_BRANCH' and tags have been pushed to '$ORIGIN'" 
  227.     fi 
  228.     echo 
  229.     }

Tags: master develop gitflow

分享到: